package mvd.jester.priority;

import mvd.jester.model.Task;
import mvd.jester.simulator.internals.TaskContextInterface;

/**
 * EarliestDeadineFirst
 */
public class EarliestDeadineFirst implements PriorityManager {

    /**
     * Compare the priority of two tasks according to the Rate Monotonic policy
     * 
     * @param t1 The first task
     * @param t2 The second task
     * @return 0 if both tasks have the same priority, positive number if the first task has a
     *         higher priority, negative number if the second task has a higher priority
     */
    @Override
    public int compare(Task t1, Task t2) {
        throw new RuntimeException(
                "Earliest Deadline First does not have Priority Manager for tasks");
    }

    @Override
    public int compare(TaskContextInterface t1, TaskContextInterface t2) {
        return (int) (t1.getDeadline() - t2.getDeadline());
    }
}
